All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 [ -n "$VCSH_DEBUG" ] && set -x
7 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
8 [ -z "$VCSH_BASE" ] && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
9 for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
11 if [ ! -d "$check_directory" ]; then
12 if [ -e "$check_directory" ]; then
13 echo "$SELF: error: $check_directory exists but is not a directory" >&2
16 echo "$SELF: info: attempting to create $check_directory"
17 mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
23 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $1"
27 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $1"; fi
30 # use <repo> Use this repository
32 # exit Exit vcsh mode" >&2
34 echo "usage: $SELF <args>
37 [<repo>] Clone from an existing repository
38 help Display this help
39 delete Delete an existing repository
40 init <repo> Initialize a new repository
43 <command> Use this repository
46 <repo> Seed .gitignore.d/<repo> from git ls-files" >&2
52 GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
54 if [ ! -d "$GIT_DIR" ]; then
55 echo E: no repository found for "$REPO_NAME" >&2
60 export GIT_WORK_TREE="$(git config --get core.worktree)"
61 export VCSH_DIRECTORY="$REPO_NAME"
66 verbose "init() begin"
68 echo "$SELF: fatal: $GIT_DIR exists" &&
70 export GIT_WORK_TREE="$HOME"
71 mkdir -p "$GIT_WORK_TREE"
72 cd "$GIT_WORK_TREE" ||
73 (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
77 git config core.worktree "$GIT_WORK_TREE"
78 git config core.excludesfile ".gitignore.d/$REPO_NAME"
79 touch "$HOME/.gitignore.d/$REPO_NAME"
80 git add "$HOME/.gitignore.d/$REPO_NAME"
90 if [ "$1" = 'help' ] || [ "$#" -eq 0 ]; then
95 elif [ "$1" = 'list' ]; then
97 for i in "$VCSH_BASE"/*.git; do
98 echo $(basename "$i" .git)
103 elif [ "$1" = 'run' ]; then
112 #elif [ "$1" = 'use' ]; then
113 # verbose "use begin"
114 # if [ -n "$ZSH_VERSION" ]; then
115 # if [ -o NO_IGNORE_EOF ]; then
116 # export VCSH_NO_IGNORE_EOF=1
124 # bindkey '^d' 'vcsh_exit'
126 # use "$2" || return 1
127 # [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
131 elif [ "$1" = 'clone' ]; then
132 verbose "clone begin"
135 [ -z "$REPO_NAME" ] && REPO_NAME=$(basename "$GIT_REMOTE" .git)
137 export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
140 git remote add origin "$GIT_REMOTE"
141 git config branch.master.remote origin
142 git config branch.master.merge refs/heads/master
143 git config core.excludesfile ".gitignore.d/$REPO_NAME"
145 for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
147 echo "$SELF: error: $object exists." &&
150 [ "$VCSH_CONFLICT" = '1' ] &&
151 echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
152 echo " Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
154 git merge origin/master
155 # use $REPO_NAME || return 1
158 elif [ "$1" = 'init' ]; then
160 [ -z $2 ] && help && echo && echo "$SELF $1: error: please specify repository to work on" && return 0
161 export REPO_NAME="$2"
162 export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
164 # use "$REPO_NAME" || return 1
167 #elif [ "$1" = 'exit' ]; then
168 # verbose "exit begin"
169 # if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
170 # unset VCSH_NO_IGNORE_EOF
171 # setopt NO_IGNORE_EOF
174 # [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
178 elif [ "$1" = 'seed-gitignore' ]; then
179 verbose "seed-gitignore begin"
180 [ -z $2 ] && help && echo && echo "$SELF $1: error: please specify repository to work on" && return 0
182 # Switching directory as this has to be executed from $HOME to be of any use.
183 # Going back into old directory at the end in case `vcsh use` is reactivated.
186 git config core.excludesfile ".gitignore.d/$REPO_NAME"
187 gitignores=$(for file in $(git ls-files); do
189 echo $file; new="${file%/*}"
190 [ "$file" = "$new" ] && break
193 done | sort -u | sed 's/^/!/')
194 tempfile=$(mktemp) ||
195 (echo "$SELF: fatal: could not create tempfile" && exit 1)
196 echo '*' > "$tempfile"
197 for gitignore in $gitignores; do
198 echo "$gitignore" >> "$tempfile"
200 diff -N "$tempfile" "$HOME/.gitignore.d/$2" > /dev/null &&
203 if [ -e "$HOME/.gitignore.d/$2" ]; then
204 echo "$SELF: info: $HOME/.gitignore.d/$2 differs from new data, moving it to $HOME/.gitignore.d/$2.bak"
205 mv -f "$HOME/.gitignore.d/$2" "$HOME/.gitignore.d/$2.bak" ||
206 (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$2 to $HOME/.gitignore.d/$2.bak" && exit 1)
208 mv -f "$tempfile" "$HOME/.gitignore.d/$2" ||
209 (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$2" && exit 1)
211 verbose "seed-gitignore end"
213 elif [ "$1" = 'delete' ]; then
214 verbose "delete begin"
216 [ -z $REPO_NAME ] && help && echo && echo "$SELF $1: error: please specify repository to work on" && return 0
219 use $REPO_NAME || return 1
220 echo "$SELF: info: This operation WILL DETROY DATA!"
221 files=$(git ls-files)
222 echo "These files would be deleted:
226 AGAIN, THIS WILL DELETE YOUR DATA!
227 To continue, type \"Yes, do as I say\""
229 [ "x$answer" = "xYes, do as I say" ] || exit
230 for file in $files; do
231 rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
233 rm -rf "$VCSH_BASE/$REPO_NAME.git" || echo "$SELF: info: could not delete '$VCSH_BASE/$REPO_NAME.git'"
239 verbose "defaulting to calling help()"